/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Contents of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.166 - (show annotations) (download)
Mon Oct 29 20:47:42 2007 UTC (11 years, 8 months ago) by jmc
Branch: MAIN
CVS Tags: checkpoint59j
Changes since 1.165: +3 -1 lines
add some taf temporary files to the Makefile "Clean" command.

1 #! /usr/bin/env bash
2 #
3 # $Header: /u/gcmpack/MITgcm/tools/genmake2,v 1.165 2007/10/08 07:33:28 mlosch Exp $
4 #
5 # Makefile generator for MITgcm UV codes
6 # created by cnh 03/98
7 # adapted by aja 06/98
8 # modified by aja 01/00
9 # rewritten in bash by eh3 08/03
10
11 # Search for particular CPP #cmds associated with packages
12 # usage: test_for_package_in_cpp_options CPP_file package_name
13 test_for_package_in_cpp_options() {
14 cpp_options=$1
15 pkg=$2
16 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24 }
25
26 # Search for particular CPP #cmds associated with MPI
27 # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28 test_for_mpi_in_cpp_eeoptions() {
29 cpp_options=$1
30 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38 }
39
40 # Search for particular string in a file. Return 1 if detected, 0 if not
41 # usage: test_for_string_in_file file string
42 test_for_string_in_file() {
43 file=$1
44 strng=$2
45 grep -i "$strng" $file > /dev/null 2>&1
46 RETVAL=$?
47 if test "x${RETVAL}" = x0 ; then
48 printf "Error: In $file there is an illegal line: "
49 grep -i "$strng" $file
50 exit 99
51 fi
52 return 0
53 }
54
55 # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
56 # the package list.
57 expand_pkg_groups() {
58 new_packages=
59 PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
60 if test -r $PKG_GROUPS ; then
61 cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
62 cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
63 matched=0
64 for i in $PACKAGES ; do
65 line=`grep "^ *$i" ./p2.tmp`
66 RETVAL=$?
67 if test "x$RETVAL" = x0 ; then
68 matched=1
69 replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
70 echo " replacing \"$i\" with: $replace"
71 new_packages="$new_packages $replace"
72 else
73 new_packages="$new_packages $i"
74 fi
75 done
76 PACKAGES=$new_packages
77 rm -f ./p[1,2].tmp
78 return $matched
79 else
80 echo "Warning: can't read package groups definition file: $PKG_GROUPS"
81 fi
82 }
83
84 # Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
85 # cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
86 check_for_broken_Ff() {
87 # Do we have defaults for $FS and/or $FS90 ?
88 tfs=f
89 tfs9=f90
90 if test "x$FS" != x ; then
91 tfs="$FS"
92 fi
93 if test "x$FS90" != x ; then
94 tfs9="$FS90"
95 fi
96
97 # First check the ability to create a *.F/.f pair.
98 cat <<EOF >> genmake_hello.F
99 program hello
100 write(*,*) 'hi'
101 stop
102 end
103 EOF
104 cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
105 RETVAL=$?
106 if test "x$RETVAL" != x0 ; then
107 if test "x$FS" = x ; then
108 FS='for'
109 FS90='fr9'
110 check_for_broken_Ff
111 else
112 cat <<EOF 2>&1
113 ERROR: Your file system cannot distinguish between *.F and *.f files
114 (fails the "cp" test) and this program cannot find a suitable
115 replacement extension. Please try a different build environment or
116 contact the <MITgcm-support@mitgcm.org> list for help.
117
118 EOF
119 exit -1
120 fi
121 return
122 fi
123 rm -f genmake_hello.*
124
125 # Check the ability of ${MAKE} and ${LN} to use the current set
126 # of extensions.
127 cat <<EOF >> genmake_hello.F
128 program hello
129 write(*,*) 'hi'
130 stop
131 end
132 EOF
133 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
134 cat <<EOF >> $MAKEFILE
135 .SUFFIXES:
136 .SUFFIXES: .$tfs .F
137 .F.$tfs:
138 $LN \$< \$@
139 EOF
140 $MAKE "genmake_hello."$tfs > /dev/null 2>&1
141 RETVAL=$?
142 if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
143 if test "x$FS" = x ; then
144 FS='for'
145 FS90='fr9'
146 check_for_broken_Ff
147 else
148 cat <<EOF 2>&1
149 ERROR: Your file system cannot distinguish between *.F and *.f files
150 (fails the "make/ln" test) and this program cannot find a suitable
151 replacement extension. Please try a different build environment or
152 contact the <MITgcm-support@mitgcm.org> list for help.
153
154 EOF
155 exit -1
156 return
157 fi
158 fi
159 rm -f genmake_hello.* $MAKEFILE
160 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
161
162 # If we make it here, use the extensions
163 FS=$tfs
164 FS90=$tfs9
165 return
166 }
167
168
169 look_for_makedepend() {
170
171 # The "original" makedepend is part of the Imake system that is
172 # most often distributed with XFree86 or with an XFree86 source
173 # package. As a result, many machines (eg. generic Linux) do not
174 # have a system-default "makedepend" available. For those
175 # systems, we have two fall-back options:
176 #
177 # 1) a makedepend implementation shipped with the cyrus-imapd
178 # package: ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
179 #
180 # 2) a known-buggy xmakedpend shell script
181 #
182 # So the choices are, in order:
183 #
184 # 1) use the user-specified program
185 # 2) use a system-wide default
186 # 3) locally build and use the cyrus implementation
187 # 4) fall back to the buggy local xmakedpend script
188 #
189 if test "x${MAKEDEPEND}" = x ; then
190 which makedepend > /dev/null 2>&1
191 RV0=$?
192 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
193 # echo 'MAKEFILE="'$MAKEFILE'"'
194 cat <<EOF >> $MAKEFILE
195 # THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196 #
197 # Some "makedepend" implementations will die if they cannot
198 # find a Makefile -- so this file is here to gives them an
199 # empty one to find and parse.
200 EOF
201 cat <<EOF >> genmake_tc.f
202 program test
203 write(*,*) 'test'
204 stop
205 end
206 EOF
207 makedepend genmake_tc.f > /dev/null 2>&1
208 RV1=$?
209 test -f $MAKEFILE && rm -f $MAKEFILE
210 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
211 if test "x${RV0}${RV1}" = x00 ; then
212 MAKEDEPEND=makedepend
213 else
214 echo " a system-default makedepend was not found."
215
216 # Try to build the cyrus implementation
217 build_cyrus_makedepend
218 RETVAL=$?
219 if test "x$RETVAL" != x0 ; then
220 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
221 fi
222 rm -f ./genmake_cy_md
223 fi
224 else
225 # echo "MAKEDEPEND=${MAKEDEPEND}"
226 echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
227 RETVAL=$?
228 if test x"$RETVAL" = x0 ; then
229 build_cyrus_makedepend
230 fi
231 fi
232 }
233
234
235 build_cyrus_makedepend() {
236 rm -f ./genmake_cy_md
237 (
238 cd $ROOTDIR/tools/cyrus-imapd-makedepend \
239 && ./configure > /dev/null 2>&1 \
240 && make > /dev/null 2>&1
241 if test -x ./makedepend.exe ; then
242 $LN ./makedepend.exe ./makedepend
243 fi
244 ./makedepend ifparser.c > /dev/null 2>&1 \
245 && echo "true"
246 ) > ./genmake_cy_md
247 grep true ./genmake_cy_md > /dev/null 2>&1
248 RETVAL=$?
249 rm -f ./genmake_cy_md
250 if test "x$RETVAL" = x0 ; then
251 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
252 return 0
253 else
254 echo "WARNING: unable to build cyrus-imapd-makedepend"
255 return 1
256 fi
257 }
258
259
260 build_embed_encode()
261 {
262 printf " building the embed-encode utility... "
263 if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264 if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265 echo
266 echo " Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267 echo
268 EMBED_SRC=f
269 return 1
270 fi
271 clist="cc gcc c89 $CC"
272 for ic in $clist ; do
273 comm="$ic -o encode_files encode_files.c"
274 ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275 RETVAL=$?
276 if test "x$RETVAL" = x0 ; then
277 echo "OK"
278 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279 return 0
280 fi
281 done
282 echo
283 echo " Error: unable to build $ROOTDIR/embed_encode/encode_files"
284 echo " so it has been disabled"
285 echo
286 EMBED_SRC=f
287 return 1
288 fi
289 echo "OK"
290 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291 }
292
293
294 # Guess possible config options for this host
295 find_possible_configs() {
296
297 tmp1=`uname`"_"`uname -m`
298 tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
299 tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
300 tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
301 tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
302 tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
303 PLATFORM=$tmp3
304 echo $PLATFORM | grep cygwin > /dev/null 2>&1 && PLATFORM=cygwin_ia32
305 OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
306 echo " The platform appears to be: $PLATFORM"
307
308 echo "test" > test
309 ln -s ./test link
310 RETVAL=$?
311 if test "x${RETVAL}" = x0 ; then
312 LN="ln -s"
313 else
314 echo "Error: \"ln -s\" does not appear to work on this system!"
315 echo " For help, please contact <MITgcm-support@mitgcm.org>."
316 exit 1
317 fi
318 rm -f test link
319
320 if test "x$CPP" = x ; then
321 CPP="cpp -traditional -P"
322 fi
323
324 look_for_makedepend
325
326 #================================================================
327 # look for possible C compilers
328 tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329 p_CC=
330 for c in $tmp ; do
331 rm -f ./genmake_hello.c ./genmake_hello
332 cat >> genmake_hello.c << EOF
333 #include <stdio.h>
334 int main(int argc, char **argv) {
335 printf("Hello!\n");
336 return 0;
337 }
338 EOF
339 $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
340 RETVAL=$?
341 if test "x${RETVAL}" = x0 ; then
342 p_CC="$p_CC $c"
343 fi
344 done
345 rm -f ./genmake_hello.c ./genmake_hello
346 if test "x${p_CC}" = x ; then
347 cat 1>&2 <<EOF
348
349 Error: No C compilers were found in your path. Please specify one using:
350
351 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
352 2) the CC or MITGCM_CC environment variables.
353
354 EOF
355 exit 1
356 else
357 echo " The possible C compilers found in your path are:"
358 echo " "$p_CC
359 if test "x$CC" = x ; then
360 CC=`echo $p_CC | $AWK '{print $1}'`
361 echo " Setting C compiler to: "$CC
362 fi
363 fi
364
365 #================================================================
366 # look for possible FORTRAN compilers
367 tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368 p_FC=
369 for c in $tmp ; do
370 rm -f ./hello.f ./hello
371 cat >> hello.f <<EOF
372 program hello
373 do i=1,3
374 print *, 'hello world : ', i
375 enddo
376 end
377 EOF
378 $c -o hello hello.f > /dev/null 2>&1
379 RETVAL=$?
380 if test "x${RETVAL}" = x0 ; then
381 p_FC="$p_FC $c"
382 fi
383 done
384 rm -f ./hello.f ./hello
385 if test "x${p_FC}" = x ; then
386 cat 1>&2 <<EOF
387
388 Error: No Fortran compilers were found in your path. Please specify one using:
389
390 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
391 2) a command-line option (eg. "-fc NAME"), or
392 3) the FC or MITGCM_FC environment variables.
393
394 EOF
395 exit 1
396 else
397 echo " The possible FORTRAN compilers found in your path are:"
398 echo " "$p_FC
399 fi
400
401 # Use the first of the compilers found in the current PATH
402 # that has a correctly-named optfile
403 if test "x$OPTFILE" = x -a "x$FC" = x ; then
404 for i in $p_FC ; do
405 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406 if test -r $OPTFILE ; then
407 echo " Setting OPTFILE to: "$OPTFILE
408 break
409 fi
410 done
411 fi
412
413 if test "x$OPTFILE" = x ; then
414 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
415 if test ! -r $OPTFILE ; then
416 echo " I looked for the file "$OPTFILE" but did not find it"
417 fi
418 fi
419 # echo " The options file: $p_OF"
420 # echo " appears to match so we'll use it."
421 # for i in $p_FC ; do
422 #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
423 #if test -r $p_OF ; then
424 # OPTFILE=$p_OF
425 # echo " The options file: $p_OF"
426 # echo " appears to match so we'll use it."
427 # break
428 #fi
429 # done
430 if test "x$OPTFILE" = x ; then
431 cat 1>&2 <<EOF
432
433 Error: No options file was found in: $ROOTDIR/tools/build_options/
434 that matches this platform ("$PLATFORM") and the compilers found in
435 your path. Please specify an "optfile" using:
436
437 1) the command line (eg. "-optfile=path/to/OPTFILE"), or
438 2) the MITGCM_OF environment variable.
439
440 If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
441
442 EOF
443 exit 1
444 fi
445
446 # # look for possible MPI libraries
447 # mpi_libs=
448 # mpi_fort=`which mpif77 2>/dev/null`
449 # RETVAL=$?
450 # if test "x${RETVAL}" = x0 ; then
451 # cat >>test.f <<EOF
452 # PROGRAM HELLO
453 # DO 10, I=1,10
454 # PRINT *,'Hello World'
455 # 10 CONTINUE
456 # STOP
457 # END
458 # EOF
459 # eval "$mpi_fort -showme test.f > out"
460 # RETVAL=$?
461 # if test "x${RETVAL}" = x0 ; then
462 # a=`cat out`
463 # for i in $a ; do
464 # case $i in
465 # -*)
466 # mpi_libs="$mpi_libs $i" ;;
467 # esac
468 # done
469 # echo "The MPI libs appear to be:"
470 # echo " "$mpi_libs
471 # fi
472 # rm -f test.f out
473 # fi
474
475 }
476
477 # Parse the package dependency information
478 get_pdepend_list() {
479
480 # strip the comments and then convert the dependency file into
481 # two arrays: PNAME, DNAME
482 cat $1 | sed -e 's/#.*$//g' \
483 | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
484 > ./.pd_tmp
485 . ./.pd_tmp
486 rm -f ./.pd_tmp
487
488 printf "PNAME = "${}
489 }
490
491
492 # Explain usage
493 usage() {
494 cat <<EOF
495
496 Usage: "$0" [OPTIONS]
497 where [OPTIONS] can be:
498
499 -help | --help | -h | --h
500 Print this help message and exit.
501
502 -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
503 -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
504 Use "NAME" as the adoptfile. By default, the file at
505 "tools/adjoint_options/adjoint_default" will be used.
506
507 -nooptfile | --nooptfile
508 -optfile NAME | --optfile NAME | -of NAME | --of NAME
509 -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
510 Use "NAME" as the optfile. By default, an attempt will be
511 made to find an appropriate "standard" optfile in the
512 tools/build_options/ directory.
513
514 -pdepend NAME | --pdepend NAME
515 -pdepend=NAME | --pdepend=NAME
516 Get package dependency information from "NAME".
517
518 -pdefault NAME | --pdefault NAME
519 -pdefault=NAME | --pdefault=NAME
520 Get the default package list from "NAME".
521
522 -make NAME | -m NAME
523 --make=NAME | -m=NAME
524 Use "NAME" for the MAKE program. The default is "make" but
525 many platforms, "gmake" is the preferred choice.
526
527 -makefile NAME | -mf NAME
528 --makefile=NAME | -mf=NAME
529 Call the makefile "NAME". The default is "Makefile".
530
531 -makedepend NAME | -md NAME
532 --makedepend=NAME | -md=NAME
533 Use "NAME" for the MAKEDEPEND program.
534
535 -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
536 -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
537 Specify the location of the MITgcm ROOTDIR as "NAME".
538 By default, genamke will try to find the location by
539 looking in parent directories (up to the 5th parent).
540
541 -mods NAME | --mods NAME | -mo NAME | --mo NAME
542 -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
543 Here, "NAME" specifies a list of directories that are
544 used for additional source code. Files found in the
545 "mods list" are given preference over files of the same
546 name found elsewhere.
547
548 -disable NAME | --disable NAME
549 -disable=NAME | --disable=NAME
550 Here "NAME" specifies a list of packages that we don't
551 want to use. If this violates package dependencies,
552 genamke will exit with an error message.
553
554 -enable NAME | --enable NAME
555 -enable=NAME | --enable=NAME
556 Here "NAME" specifies a list of packages that we wish
557 to specifically enable. If this violates package
558 dependencies, genamke will exit with an error message.
559
560 -standarddirs NAME | --standarddirs NAME
561 -standarddirs=NAME | --standarddirs=NAME
562 Here, "NAME" specifies a list of directories to be
563 used as the "standard" code.
564
565 -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
566 -fc=NAME | --fc=NAME
567 Use "NAME" as the fortran compiler. By default, genmake
568 will search for a working compiler by trying a list of
569 "usual suspects" such as g77, f77, etc.
570
571 -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
572 Use "NAME" as the C compiler. By default, genmake
573 will search for a working compiler by trying a list of
574 "usual suspects" such as gcc, c89, cc, etc.
575
576 -[no]ieee | --[no]ieee
577 Do or don't use IEEE numerics. Note that this option
578 *only* works if it is supported by the OPTFILE that
579 is being used.
580
581 -ignoretime | -ignore_time | --ignoretime | --ignore_time
582 Ignore all the "wall clock" routines entirely. This will
583 not in any way hurt the model results -- it simply means
584 that the code that checks how long the model spends in
585 various routines will give junk values.
586
587 -ts | --ts
588 Produce timing information per timestep
589 -papis | --papis
590 Produce summary MFlop/s (and IPC) with PAPI per timestep
591 -pcls | --pcls
592 Produce summary MFlop/s etc. with PCL per timestep
593 -foolad | --foolad
594 Fool the AD code generator
595 -papi | --papi
596 Performance analysis with PAPI
597 -pcl | --pcl
598 Performance analysis with PCL
599 -hpmt | --hpmt
600 Performance analysis with the HPM Toolkit
601
602 -gsl | --gsl
603 Use GSL to control floating point rounding and precision
604 -devel | --devel
605 Add additional warning and debugging flags for development
606
607 -mpi | --mpi
608 Include MPI header files and link to MPI libraries
609 -mpi=PATH | --mpi=PATH
610 Include MPI header files and link to MPI libraries using MPI_ROOT
611 set to PATH. i.e. Include files from \$PATH/include, link to libraries
612 from \$PATH/lib and use binaries from \$PATH/bin.
613
614 -es | --es | -embed-source | --embed-source
615 Embed a tarball containing the full source code
616 (including the Makefile, etc.) used to build the
617 executable [off by default]
618
619 -bash NAME
620 Explicitly specify the Bourne or BASH shell to use
621
622 While it is most often a single word, the "NAME" variables specified
623 above can in many cases be a space-delimited string such as:
624
625 --enable pkg1 --enable 'pkg1 pkg2' --enable 'pkg1 pkg2 pkg3'
626 -mods=dir1 -mods='dir1' -mods='dir1 dir2 dir3'
627 -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
628
629 which, depending upon your shell, may need to be single-quoted.
630
631 For more detailed genmake documentation, please see:
632
633 http://mitgcm.org/devel_HOWTO/
634
635 EOF
636
637 exit 1
638 }
639
640 # Build a CPP macro to automate calling C routines from FORTRAN
641 get_fortran_c_namemangling() {
642
643 #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
644 if test ! "x$FC_NAMEMANGLE" = x ; then
645 return 0
646 fi
647
648 default_nm="#define FC_NAMEMANGLE(X) X ## _"
649
650 cat > genmake_test.c <<EOF
651 void tcall( char * string ) { tsub( string ); }
652 EOF
653 $MAKE genmake_test.o >> genmake_warnings 2>&1
654 RETVAL=$?
655 if test "x$RETVAL" != x0 ; then
656 FC_NAMEMANGLE=$default_nm
657 cat <<EOF>> genmake_errors
658
659 WARNING: C test compile fails
660 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
661 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
662 EOF
663 return 1
664 fi
665 c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
666 RETVAL=$?
667 if test "x$RETVAL" != x0 ; then
668 FC_NAMEMANGLE=$default_nm
669 cat <<EOF>> genmake_warnings
670
671 WARNING: The "nm" command failed.
672 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
673 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
674 EOF
675 return 1
676 fi
677 cat > genmake_tcomp.$FS <<EOF
678 subroutine tcall( string )
679 character*(*) string
680 call tsub( string )
681 end
682 EOF
683 $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
684 RETVAL=$?
685 if test "x$RETVAL" != x0 ; then
686 FC_NAMEMANGLE=$default_nm
687 cat <<EOF>> genmake_warnings
688
689 WARNING: FORTRAN test compile fails -- please see "genmake_errors"
690 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
691 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
692 EOF
693 return 1
694 fi
695 f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
696 RETVAL=$?
697 if test "x$RETVAL" != x0 ; then
698 FC_NAMEMANGLE=$default_nm
699 cat <<EOF>> genmake_warnings
700
701 WARNING: The "nm" command failed.
702 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
703 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
704 EOF
705 return 1
706 fi
707
708 c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
709 f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
710 c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
711 f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
712
713 nmangle="X"
714 if test "x$c_a" != "x$f_a" ; then
715 comm="echo x$f_a | sed -e 's|x$c_a||'"
716 a=`eval $comm`
717 nmangle="$a ## $nmangle"
718 fi
719 if test "x$c_b" != "x$f_b" ; then
720 comm="echo x$f_b | sed -e 's|x$c_b||'"
721 b=`eval $comm`
722 nmangle="$nmangle ## $b"
723 fi
724
725 FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) $nmangle"
726
727 # cleanup the testing files
728 rm -f genmake_tcomp.* genmake_test.*
729 }
730
731
732 check_HAVE_CLOC() {
733 get_fortran_c_namemangling
734 cat <<EOF > genmake_tc_1.c
735 $FC_NAMEMANGLE
736 #include <stdio.h>
737 #include <stdlib.h>
738 #include <unistd.h>
739 #include <assert.h>
740 #include <sys/time.h>
741 void FC_NAMEMANGLE(cloc) ( double *curtim )
742 {
743 struct timeval tv1;
744 gettimeofday(&tv1 , (void *)NULL );
745 *curtim = (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
746 *curtim = *curtim/1.E6;
747 }
748 EOF
749 make genmake_tc_1.o >> genmake_warnings 2>&1
750 RET_C=$?
751 cat <<EOF > genmake_tc_2.$FS
752 program hello
753 REAL*8 wtime
754 external cloc
755 call cloc(wtime)
756 print *," HELLO WORLD", wtime
757 end
758 EOF
759 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
760 echo $COMM >> genmake_warnings
761 $COMM >> genmake_warnings 2>&1
762 RET_F=$?
763 test -x ./genmake_tc && ./genmake_tc >> genmake_warnings 2>&1
764 RETVAL=$?
765 if test "x$RETVAL" = x0 ; then
766 HAVE_CLOC=t
767 DEFINES="$DEFINES -DHAVE_CLOC"
768 fi
769 rm -f genmake_tc*
770 }
771
772
773 check_HAVE_SIGREG() {
774 if test ! "x$HAVE_SIGREG" = x ; then
775 return
776 fi
777 get_fortran_c_namemangling
778 cat <<EOF > genmake_tc_1.c
779 $FC_NAMEMANGLE
780 #include <stdlib.h>
781 #include <stdio.h>
782 #include <signal.h>
783 #include <errno.h>
784 #include <ucontext.h>
785
786 int * ip;
787
788 static void killhandler(
789 unsigned int sn, siginfo_t si, struct ucontext *sc )
790 {
791 *ip = *ip + 1;
792 return;
793 }
794
795 void FC_NAMEMANGLE(sigreg) (int * aip)
796 {
797 struct sigaction s;
798 ip = aip;
799 s.sa_flags = SA_SIGINFO;
800 s.sa_sigaction = (void *)killhandler;
801 if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
802 printf("Sigaction returned error = %d\n", errno);
803 exit(0);
804 }
805 return;
806 }
807 EOF
808 make genmake_tc_1.o >> genmake_warnings 2>&1
809 RET_C=$?
810 cat <<EOF > genmake_tc_2.$FS
811 program hello
812 integer anint
813 common /iv/ anint
814 external sigreg
815 call sigreg(anint)
816 end
817 EOF
818 echo >> genmake_warnings
819 echo "running: check_HAVE_SIGREG()" >> genmake_warnings
820 cat genmake_tc_2.$FS >> genmake_warnings
821 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
822 echo $COMM >> genmake_warnings
823 $COMM >> genmake_warnings 2>&1
824 RETVAL=$?
825 if test "x$RETVAL" = x0 ; then
826 HAVE_SIGREG=t
827 DEFINES="$DEFINES -DHAVE_SIGREG"
828 fi
829 rm -f genmake_tc*
830 }
831
832
833 check_HAVE_SETRLSTK() {
834 if test "x$HAVE_SETRLSTK" = xt ; then
835 DEFINES="$DEFINES -DHAVE_SETRLSTK"
836 return
837 fi
838 if test ! "x$HAVE_SETRLSTK" = x ; then
839 return
840 fi
841 get_fortran_c_namemangling
842 cat <<EOF > genmake_tc_1.c
843 $FC_NAMEMANGLE
844 #include <sys/time.h>
845 #include <sys/resource.h>
846 #include <unistd.h>
847 void FC_NAMEMANGLE(setrlstk) ()
848 {
849 struct rlimit rls;
850 rls.rlim_cur = RLIM_INFINITY;
851 rls.rlim_max = RLIM_INFINITY;
852 setrlimit(RLIMIT_STACK, &rls);
853 return;
854 }
855 EOF
856 make genmake_tc_1.o >> genmake_warnings 2>&1
857 RET_C=$?
858 cat <<EOF > genmake_tc_2.$FS
859 program hello
860 external setrlstk
861 call setrlstk()
862 end
863 EOF
864 echo >> genmake_warnings
865 echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
866 cat genmake_tc_2.$FS >> genmake_warnings
867 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
868 echo $COMM >> genmake_warnings
869 $COMM >> genmake_warnings 2>&1
870 RETVAL=$?
871 if test "x$RETVAL" = x0 ; then
872 HAVE_SETRLSTK=t
873 DEFINES="$DEFINES -DHAVE_SETRLSTK"
874 fi
875 rm -f genmake_tc*
876 }
877
878
879 check_HAVE_STAT() {
880 get_fortran_c_namemangling
881 cat <<EOF > genmake_tc_1.c
882 $FC_NAMEMANGLE
883 #include <stdio.h>
884 #include <stdlib.h>
885 #include <unistd.h>
886 #include <sys/stat.h>
887 #include <sys/types.h>
888 void FC_NAMEMANGLE(tfsize) ( int *nbyte )
889 {
890 char name[512];
891 struct stat astat;
892
893 name[0] = 'a'; name[1] = '\0';
894 if (! stat(name, &astat))
895 *nbyte = (int)(astat.st_size);
896 else
897 *nbyte = -1;
898 }
899 EOF
900 make genmake_tc_1.o >> genmake_tc.log 2>&1
901 RET_C=$?
902 cat <<EOF > genmake_tc_2.$FS
903 program hello
904 integer nbyte
905 call tfsize(nbyte)
906 print *," HELLO WORLD", nbyte
907 end
908 EOF
909 echo >> genmake_warnings
910 echo "running: check_HAVE_STAT()" >> genmake_warnings
911 cat genmake_tc_2.$FS >> genmake_warnings
912 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
913 echo $COMM >> genmake_warnings
914 $COMM >> genmake_tc.log 2>&1
915 RETVAL=$?
916 if test "x$RETVAL" = x0 ; then
917 HAVE_STAT=t
918 DEFINES="$DEFINES -DHAVE_STAT"
919 fi
920 rm -f genmake_tc*
921 }
922
923
924 check_netcdf_libs() {
925 if test ! "x$SKIP_NETCDF_CHECK" = x ; then
926 return
927 fi
928 echo >> genmake_warnings
929 echo "running: check_netcdf_libs()" >> genmake_warnings
930 cat <<EOF > genmake_tnc.F
931 program fgennc
932 #include "netcdf.inc"
933 EOF
934 if test ! "x$MPI" = x ; then
935 echo '#include "mpif.h"' >> genmake_tnc.F
936 fi
937 cat <<EOF >> genmake_tnc.F
938 integer iret, ncid, xid
939 iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
940 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
941 iret = nf_def_dim(ncid, 'X', 11, xid)
942 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
943 iret = nf_close(ncid)
944 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
945 end
946 EOF
947 echo "=== genmake_tnc.F ===" > genmake_tnc.log
948 cat genmake_tnc.F >> genmake_tnc.log
949 echo "=== genmake_tnc.F ===" >> genmake_tnc.log
950 RET_CPP=f
951 COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
952 echo "$COMM" >> genmake_tnc.log
953 eval $COMM > genmake_tnc.$FS 2>/dev/null && RET_CPP=t
954 if test "x$RET_CPP" = xf ; then
955 echo " WARNING: CPP failed to pre-process the netcdf test." \
956 >> genmake_tnc.log
957 echo " Please check that \$INCLUDES is properly set." \
958 >> genmake_tnc.log
959 fi
960 echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
961 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
962 $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
963 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
964 RET_COMPILE=$?
965 cat genmake_tnc.log >> genmake_warnings
966
967 #EH3 Remove test program execution for machines that either disallow
968 #EH3 execution or cannot support it (eg. cross-compilers)
969 #EH3
970 #EH3 test -x ./genmake_tnc && ./genmake_tnc >> genmake_tnc.log 2>&1
971 #EH3 RETVAL=$?
972 #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
973
974 if test "x$RET_COMPILE" = x0 ; then
975 HAVE_NETCDF=t
976 else
977 # try again with "-lnetcdf" added to the libs
978 echo "try again with added '-lnetcdf'" > genmake_tnc.log
979 echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
980 echo " && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
981 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
982 cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null \
983 && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
984 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
985 RET_COMPILE=$?
986 cat genmake_tnc.log >> genmake_warnings
987 if test "x$RET_COMPILE" = x0 ; then
988 LIBS="$LIBS -lnetcdf"
989 HAVE_NETCDF=t
990 else
991 # try again with "-lnetcdff" added to the libs
992 echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
993 echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
994 echo " && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
995 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
996 cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null \
997 && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
998 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
999 RET_COMPILE=$?
1000 cat genmake_tnc.log >> genmake_warnings
1001 if test "x$RET_COMPILE" = x0 ; then
1002 LIBS="$LIBS -lnetcdff -lnetcdf"
1003 HAVE_NETCDF=t
1004 fi
1005 fi
1006 fi
1007 rm -f genmake_tnc*
1008 }
1009
1010
1011
1012 ###############################################################################
1013 # Sequential part of script starts here
1014 ###############################################################################
1015
1016 # Set defaults here
1017 COMMANDL="$0 $@"
1018
1019 PLATFORM=
1020 LN=
1021 S64=
1022 KPP=
1023 #FC=
1024 #CC=gcc
1025 #CPP=
1026 LINK=
1027 DEFINES=
1028 PACKAGES=
1029 ENABLE=
1030 DISABLE=
1031 # MAKEFILE=
1032 # MAKEDEPEND=
1033 PDEPEND=
1034 DUMPSTATE=t
1035 PDEFAULT=
1036 OPTFILE=
1037 INCLUDES="-I. $INCLUDES"
1038 FFLAGS=
1039 FOPTIM=
1040 FEXTRAFLAGS=
1041 CFLAGS=
1042 KFLAGS1=
1043 KFLAGS2=
1044 #LDADD=
1045 LIBS=
1046 KPPFILES=
1047 NOOPTFILES=
1048 NOOPTFLAGS=
1049 MPI=
1050 MPIPATH=
1051 TS=
1052 PAPIS=
1053 PCLS=
1054 FOOLAD=
1055 PAPI=
1056 PCL=
1057 HPMT=
1058 GSL=
1059 DEVEL=
1060 HAVE_TEST_L=
1061
1062 # DEFINES checked by test compilation or command-line
1063 HAVE_SYSTEM=
1064 HAVE_FDATE=
1065 FC_NAMEMANGLE=
1066 HAVE_CLOC=
1067 # HAVE_SETRLSTK=
1068 HAVE_STAT=
1069 HAVE_NETCDF=
1070 HAVE_ETIME=
1071 IGNORE_TIME=
1072
1073 MODS=
1074 TOOLSDIR=
1075 SOURCEDIRS=
1076 INCLUDEDIRS=
1077 STANDARDDIRS="USE_THE_DEFAULT"
1078
1079 G2ARGS=
1080 BASH=
1081 PWD=`pwd`
1082 test "x$MAKE" = x && MAKE=make
1083 test "x$AWK" = x && AWK=awk
1084 EMBED_SRC=
1085 THISHOST=`hostname`
1086 THISCWD=`pwd`
1087 THISDATE=`date`
1088 THISUSER=`echo $USER`
1089 THISVER=
1090 MACHINE=`uname -a`
1091 EXECUTABLE=
1092 EXEHOOK=
1093 EXEDIR=
1094 PACKAGES_CONF=
1095 IEEE=
1096 if test "x$MITGCM_IEEE" != x ; then
1097 IEEE=$MITGCM_IEEE
1098 fi
1099 FS=
1100 FS90=
1101
1102 AUTODIFF_PKG_USED=f
1103 AD_OPTFILE=
1104 TAF=
1105 AD_TAF_FLAGS=
1106 FTL_TAF_FLAGS=
1107 SVD_TAF_FLAGS=
1108 TAF_EXTRA=
1109 TAMC=
1110 AD_TAMC_FLAGS=
1111 FTL_TAF_FLAGS=
1112 SVD_TAMC_FLAGS=
1113 TAMC_EXTRA=
1114
1115
1116 # The following state can be set directly by command-line switches
1117 gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1118 gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1119
1120 # The following state is not directly set by command-line switches
1121 gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1122 gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1123 gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1124 gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
1125 gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
1126
1127 # The following are all related to adjoint/tangent-linear stuff
1128 gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
1129 gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1130 gm_s12="TAF_EXTRA TAMC_EXTRA"
1131
1132 gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
1133 gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
1134
1135 cat <<EOF
1136
1137 GENMAKE :
1138
1139 A program for GENerating MAKEfiles for the MITgcm project. For a
1140 quick list of options, use "genmake -h" or for more detail see:
1141
1142 http://mitgcm.org/devel_HOWTO/
1143
1144 EOF
1145
1146 echo "=== Processing options files and arguments ==="
1147 gm_local="genmake_local"
1148 for i in . $MODS ; do
1149 if test -r $i/$gm_local ; then
1150 . $i/$gm_local
1151 break
1152 fi
1153 done
1154 printf " getting local config information: "
1155 if test -f $gm_local ; then
1156 echo "using $gm_local"
1157 . $gm_local
1158 # echo "DISABLE=$DISABLE"
1159 # echo "ENABLE=$ENABLE"
1160 else
1161 echo "none found"
1162 fi
1163
1164 #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
1165 #OPTIONS=
1166 #n=0
1167 #for i ; do
1168 # echo "$i $n"
1169 # setvar="OPTIONS[$n]='$i'"
1170 # # echo " $setvar"
1171 # eval "$setvar"
1172 # n=$(( $n + 1 ))
1173 #done
1174 #parse_options
1175 ac_prev=
1176 for ac_option in "$@" ; do
1177
1178 G2ARGS="$G2ARGS \"$ac_option\""
1179
1180 # If the previous option needs an argument, assign it.
1181 if test -n "$ac_prev"; then
1182 eval "$ac_prev=\$ac_option"
1183 ac_prev=
1184 continue
1185 fi
1186
1187 ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
1188
1189 case $ac_option in
1190
1191 -help | --help | -h | --h)
1192 usage ;;
1193
1194 -nooptfile | --nooptfile)
1195 OPTFILE="NONE" ;;
1196 -optfile | --optfile | -of | --of)
1197 ac_prev=OPTFILE ;;
1198 -optfile=* | --optfile=* | -of=* | --of=*)
1199 OPTFILE=$ac_optarg ;;
1200
1201 -adoptfile | --adoptfile | -adof | --adof)
1202 ac_prev=AD_OPTFILE ;;
1203 -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
1204 AD_OPTFILE=$ac_optarg ;;
1205
1206 -pdepend | --pdepend)
1207 ac_prev=PDEPEND ;;
1208 -pdepend=* | --pdepend=*)
1209 PDEPEND=$ac_optarg ;;
1210
1211 -pdefault | --pdefault)
1212 ac_prev=PDEFAULT ;;
1213 -pdefault=* | --pdefault=*)
1214 PDEFAULT=$ac_optarg ;;
1215
1216 -make | --make | -m | --m)
1217 ac_prev=MAKE ;;
1218 -make=* | --make=* | -m=* | --m=*)
1219 MAKE=$ac_optarg ;;
1220
1221 -bash | --bash)
1222 ac_prev=BASH ;;
1223 -bash=* | --bash=*)
1224 BASH=$ac_optarg ;;
1225
1226 -makedepend | --makedepend | -md | --md)
1227 ac_prev=MAKEDEPEND ;;
1228 -makedepend=* | --makedepend=* | -md=* | --md=*)
1229 MAKEDEPEND=$ac_optarg ;;
1230
1231 -makefile | --makefile | -ma | --ma)
1232 ac_prev=MAKEFILE ;;
1233 -makefile=* | --makefile=* | -ma=* | --ma=*)
1234 MAKEFILE=$ac_optarg ;;
1235
1236 -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
1237 echo "ERROR: The platform option has been removed. Please specify"
1238 echo " the build options using the \"optfile\" mechanism."
1239 echo
1240 usage
1241 ;;
1242
1243 -rootdir | --rootdir | -rd | --rd)
1244 ac_prev=ROOTDIR ;;
1245 -rootdir=* | --rootdir=* | -rd=* | --rd=*)
1246 ROOTDIR=$ac_optarg ;;
1247
1248 -mods | --mods | -mo | --mo)
1249 ac_prev=MODS ;;
1250 -mods=* | --mods=* | -mo=* | --mo=*)
1251 MODS=$ac_optarg ;;
1252
1253 -disable | --disable)
1254 ac_prev=DISABLE ;;
1255 -disable=* | --disable=*)
1256 DISABLE=$ac_optarg ;;
1257
1258 -enable | --enable)
1259 ac_prev=ENABLE ;;
1260 -enable=* | --enable=*)
1261 ENABLE=$ac_optarg ;;
1262
1263 -standarddirs | --standarddirs)
1264 ac_prev=STANDARDDIRS ;;
1265 -standarddirs=* | --standarddirs=*)
1266 STANDARDDIRS=$ac_optarg ;;
1267
1268 # -cpp | --cpp)
1269 # ac_prev=cpp ;;
1270 # -cpp=* | --cpp=*)
1271 # CPP=$ac_optarg ;;
1272
1273 -cc | --cc)
1274 ac_prev=CC ;;
1275 -cc=* | --cc=*)
1276 CC=$ac_optarg ;;
1277
1278 -fortran | --fortran | -fc | --fc)
1279 ac_prev=FC ;;
1280 -fc=* | --fc=*)
1281 FC=$ac_optarg ;;
1282
1283 -fs | --fs)
1284 ac_prev=FS ;;
1285 -fs=* | --fs=*)
1286 FS=$ac_optarg ;;
1287
1288 -fs90 | --fs90)
1289 ac_prev=FS90 ;;
1290 -fs90=* | --fs90=*)
1291 FS90=$ac_optarg ;;
1292
1293 -ieee | --ieee)
1294 IEEE=true ;;
1295 -noieee | --noieee)
1296 IEEE= ;;
1297
1298 -ts | --ts)
1299 TS=true ;;
1300 -papis | --papis)
1301 PAPIS=true ;;
1302 -pcls | --pcls)
1303 PCLS=true ;;
1304 -foolad | --foolad)
1305 FOOLAD=true ;;
1306 -papi | --papi)
1307 PAPI=true ;;
1308 -pcl | --pcl)
1309 PCL=true ;;
1310 -hpmt | --hpmt)
1311 HPMT=true ;;
1312
1313 -gsl | --gsl)
1314 GSL=true ;;
1315
1316 -devel | --devel)
1317 DEVEL=true ;;
1318
1319 -mpi | --mpi)
1320 MPI=true ;;
1321 -mpi=* | --mpi=*)
1322 MPIPATH=$ac_optarg
1323 MPI=true ;;
1324
1325 # -jam | --jam)
1326 # JAM=1 ;;
1327 # -nojam | --nojam)
1328 # JAM=0 ;;
1329
1330 -ds | --ds)
1331 DUMPSTATE=t ;;
1332
1333 -taf_extra | --taf_extra)
1334 ac_prev=TAF_EXTRA ;;
1335 -taf_extra=* | --taf_extra=*)
1336 TAF_EXTRA=$ac_optarg ;;
1337
1338 -tamc_extra | --tamc_extra)
1339 ac_prev=TAMC_EXTRA ;;
1340 -tamc_extra=* | --tamc_extra=*)
1341 TAMC_EXTRA=$ac_optarg ;;
1342
1343 -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1344 IGNORE_TIME="-DIGNORE_TIME" ;;
1345
1346 -es | --es | -embed-source | --embed-source)
1347 EMBED_SRC=t ;;
1348
1349 -*)
1350 echo "Error: unrecognized option: "$ac_option
1351 usage
1352 ;;
1353
1354 *)
1355 echo "Error: unrecognized argument: "$ac_option
1356 usage
1357 ;;
1358
1359 esac
1360
1361 done
1362
1363
1364 if test -f ./.genmakerc ; then
1365 echo
1366 echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1367 echo " file. This file format is no longer supported. For directions on"
1368 echo " how to setup and use the new \"genmake2\" script, please see:"
1369 echo " http://mitgcm.org/devel_HOWTO/"
1370 echo " and send an email to MITgcm-support@mitgcm.org if you need help."
1371 echo "WARNING: ignore \"./.genmakerc\" and continue."
1372 echo
1373 fi
1374
1375 # Find the MITgcm ${ROOTDIR}
1376 if test "x${ROOTDIR}" = x ; then
1377 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1378 if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1379 ROOTDIR=".."
1380 else
1381 for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1382 if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1383 ROOTDIR=$d
1384 printf "Warning: ROOTDIR was not specified but there appears to be"
1385 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1386 break
1387 fi
1388 done
1389 fi
1390 fi
1391 if test "x${ROOTDIR}" = x ; then
1392 echo "Error: Cannot determine ROOTDIR for MITgcm code."
1393 echo " Please specify a ROOTDIR using either an options "
1394 echo " file or a command-line option."
1395 exit 1
1396 fi
1397 if test ! -d ${ROOTDIR} ; then
1398 echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
1399 exit 1
1400 fi
1401
1402 # Find the MITgcm ${THISVER}
1403 if test -f "${ROOTDIR}/doc/tag-index" ; then
1404 THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1405 fi
1406
1407 if test "x$MAKEFILE" = x ; then
1408 MAKEFILE="Makefile"
1409 fi
1410
1411 echo " getting OPTFILE information: "
1412 if test "x${OPTFILE}" = x ; then
1413 if test "x$MITGCM_OF" = x ; then
1414 echo "Warning: no OPTFILE specified so we'll look for possible settings"
1415 printf "\n=== Searching for possible settings for OPTFILE ===\n"
1416 find_possible_configs
1417 else
1418 OPTFILE=$MITGCM_OF
1419 fi
1420 fi
1421 if test "x$OPTFILE" != xNONE ; then
1422 if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1423 echo " using OPTFILE=\"$OPTFILE\""
1424 . "$OPTFILE"
1425 RETVAL=$?
1426 if test "x$RETVAL" != x0 ; then
1427 printf "Error: failed to source OPTFILE \"$OPTFILE\""
1428 echo "--please check that variable syntax is bash-compatible"
1429 exit 1
1430 fi
1431 if test "x$DUMPSTATE" != xf ; then
1432 cp -f $OPTFILE "genmake_optfile"
1433 fi
1434 else
1435 echo "Error: can't read OPTFILE=\"$OPTFILE\""
1436 exit 1
1437 fi
1438 fi
1439
1440 echo " getting AD_OPTFILE information: "
1441 if test "x${AD_OPTFILE}" = x ; then
1442 if test "x$MITGCM_AD_OF" = x ; then
1443 AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
1444 else
1445 AD_OPTFILE=$MITGCM_AD_OF
1446 fi
1447 fi
1448 if test "x${AD_OPTFILE}" != xNONE ; then
1449 if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1450 echo " using AD_OPTFILE=\"$AD_OPTFILE\""
1451 . "$AD_OPTFILE"
1452 RETVAL=$?
1453 if test "x$RETVAL" != x0 ; then
1454 printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1455 echo "--please check that variable syntax is bash-compatible"
1456 exit 1
1457 fi
1458 if test "x$DUMPSTATE" != xf ; then
1459 cp -f $AD_OPTFILE "genmake_ad_optfile"
1460 fi
1461 else
1462 echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
1463 exit 1
1464 fi
1465 fi
1466
1467 #====================================================================
1468 # Set default values if not set by the optfile
1469 #
1470 # Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined. If not,
1471 # either set defaults or complain and abort!
1472 if test ! "x$BASH" = x ; then
1473 # add a trailing space so that it works within the Makefile syntax (see below)
1474 BASH="$BASH "
1475 fi
1476 if test "x$FC" = x ; then
1477 cat <<EOF 1>&2
1478
1479 Error: no Fortran compiler: please specify using one of the following:
1480 1) within the options file ("FC=...") as specified by "-of=OPTFILE"
1481 2) the "-fc=XXX" command-line option
1482 3) the "./genmake_local" file
1483 EOF
1484 exit 1
1485 fi
1486 if test "x$CC" = x ; then
1487 CC=cc
1488 # cat <<EOF 1>&2
1489 # Error: no C compiler: please specify using one of the following:
1490 # 1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1491 # 2) the "-cc=XXX" command-line option
1492 # 3) the "./genmake_local" file
1493 # EOF
1494 # exit 1
1495 fi
1496 if test "x$LINK" = x ; then
1497 LINK=$FC
1498 fi
1499 if test "x$MAKE" = x ; then
1500 MAKE="make"
1501 fi
1502 if test "x$CPP" = x ; then
1503 CPP=cpp
1504 fi
1505 #EH3 === UGLY ===
1506 # The following is an ugly little hack to check for $CPP in /lib/ and
1507 # it should eventually be replaced with a more general function that
1508 # searches a combo of the user's path and a list of "usual suspects"
1509 # to find the correct location for binaries such as $CPP.
1510 for i in " " "/lib/" ; do
1511 echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1512 done
1513 #EH3 === UGLY ===
1514 echo "#define A a" | $CPP > test_cpp 2>&1
1515 RETVAL=$?
1516 if test "x$RETVAL" != x0 ; then
1517 cat <<EOF 1>&2
1518
1519 Error: C pre-processor "$CPP" failed the test case: please specify using:
1520
1521 1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1522 2) the "./genmake_local" file
1523 3) with the CPP environment variable
1524
1525 EOF
1526 exit 1
1527 else
1528 rm -f test_cpp
1529 fi
1530 look_for_makedepend
1531 if test "x$LN" = x ; then
1532 LN="ln -s"
1533 fi
1534 echo "test" > genmake_test_ln
1535 $LN genmake_test_ln genmake_tlink
1536 RETVAL=$?
1537 if test "x$RETVAL" != x0 ; then
1538 cat <<EOF 1>&2
1539
1540 Error: The command "ln -s" failed -- please specify a working soft-link
1541 command in the optfile.
1542
1543 EOF
1544 exit 1
1545 fi
1546 test -L genmake_tlink > /dev/null 2>&1
1547 RETVAL=$?
1548 if test "x$RETVAL" = x0 ; then
1549 HAVE_TEST_L=t
1550 fi
1551 rm -f genmake_test_ln genmake_tlink
1552
1553 # Check for broken *.F/*.f handling and fix if possible
1554 check_for_broken_Ff
1555
1556 if test ! "x$MPI" = x ; then
1557 echo " Turning on MPI cpp macros"
1558 DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1559 fi
1560
1561 if test ! "x$TS" = x ; then
1562 echo " Turning on timing per timestep"
1563 if test ! "x$FOOLAD" = x ; then
1564 DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1565 else
1566 DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1567 fi
1568 PACKAGES="$PACKAGES showflops"
1569 fi
1570 if test ! "x$PAPIS" = x ; then
1571 echo " Turning on PAPI flop summary per timestep"
1572 echo " Please make sure PAPIINC, PAPILIB are defined"
1573 if test ! "x$FOOLAD" = x ; then
1574 DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1575 else
1576 DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1577 fi
1578 INCLUDES="$INCLUDES $PAPIINC"
1579 LIBS="$LIBS $PAPILIB"
1580 PACKAGES="$PACKAGES showflops"
1581 fi
1582 if test ! "x$PCLS" = x ; then
1583 echo " Turning on PCL counter summary per timestep"
1584 echo " Please make sure PCLINC, PCLLIB are defined"
1585 if test ! "x$FOOLAD" = x ; then
1586 DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1587 else
1588 DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1589 fi
1590 INCLUDES="$INCLUDES $PCLINC"
1591 LIBS="$LIBS $PCLLIB"
1592 PACKAGES="$PACKAGES showflops"
1593 fi
1594 if test ! "x$PAPI" = x ; then
1595 if test ! "x$PAPIS" = x ; then
1596 echo " PAPI performance analysis and flop summary per timestep cannot co-exist!"
1597 echo " Sticking with PAPI flop summary per timestep!"
1598 else
1599 echo " Turning on performance analysis with PAPI"
1600 echo " Please make sure PAPIINC, PAPILIB are defined"
1601 DEFINES="$DEFINES -DUSE_PAPI"
1602 INCLUDES="$INCLUDES $PAPIINC"
1603 LIBS="$LIBS $PAPILIB"
1604 fi
1605 fi
1606 if test ! "x$PCL" = x ; then
1607 if test ! "x$PCLS" = x ; then
1608 echo " PCL performance analysis and flop summary per timestep cannot co-exist!"
1609 echo " Sticking with PCL flop summary per timestep!"
1610 else
1611 echo " Turning on performance analysis with PCL"
1612 echo " Please make sure PCLINC, PCLLIB are defined"
1613 DEFINES="$DEFINES -DUSE_PCL"
1614 INCLUDES="$INCLUDES $PCLINC"
1615 LIBS="$LIBS $PCLLIB"
1616 fi
1617 fi
1618 if test ! "x$HPMT" = x ; then
1619 if test ! "x$PAPI" = x ; then
1620 echo " PAPI and the HPM Toolkit cannot co-exist!"
1621 echo " Sticking with PAPI!"
1622 else if test ! "x$PCL" = x ; then
1623 echo " PCL and the HPM Toolkit cannot co-exist!"
1624 echo " Sticking with PCL!"
1625 else
1626 echo " Turning on performance analysis with the HPM Toolkit"
1627 echo " Please make sure HPMTINC, HPMTLIB are defined"
1628 DEFINES="$DEFINES -DUSE_LIBHPM"
1629 INCLUDES="$INCLUDES $HPMTINC"
1630 LIBS="$LIBS $HPMTLIB"
1631 fi
1632 fi
1633 fi
1634 if test ! "x$GSL" = x ; then
1635 echo " Turning on use of GSL to control floating point calculations"
1636 echo " Please make sure GSLINC, GSLLIB are defined"
1637 DEFINES="$DEFINES -DUSE_GSL_IEEE"
1638 INCLUDES="$INCLUDES $GSLINC"
1639 LIBS="$LIBS $GSLLIB"
1640 fi
1641
1642 printf "\n=== Checking system libraries ===\n"
1643 printf " Do we have the system() command using $FC... "
1644 cat > genmake_tcomp.$FS <<EOF
1645 program hello
1646 call system('echo hi')
1647 end
1648 EOF
1649 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1650 RETVAL=$?
1651 if test "x$RETVAL" = x0 ; then
1652 HAVE_SYSTEM=t
1653 DEFINES="$DEFINES -DHAVE_SYSTEM"
1654 echo "yes"
1655 else
1656 HAVE_SYSTEM=
1657 echo "no"
1658 fi
1659 rm -f genmake_tcomp*
1660
1661 printf " Do we have the fdate() command using $FC... "
1662 cat > genmake_tcomp.$FS <<EOF
1663 program hello
1664 CHARACTER*(128) string
1665 string = ' '
1666 call fdate( string )
1667 print *, string
1668 end
1669 EOF
1670 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1671 RETVAL=$?
1672 if test "x$RETVAL" = x0 ; then
1673 HAVE_FDATE=t
1674 DEFINES="$DEFINES -DHAVE_FDATE"
1675 echo "yes"
1676 else
1677 HAVE_FDATE=
1678 echo "no"
1679 fi
1680 rm -f genmake_tcomp*
1681
1682 printf " Do we have the etime() command using $FC... "
1683 cat > genmake_tcomp.$FS <<EOF
1684 program hello
1685 REAL*4 ACTUAL, TARRAY(2)
1686 EXTERNAL ETIME
1687 REAL*4 ETIME
1688 actual = etime( tarray )
1689 print *, tarray
1690 end
1691 EOF
1692 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1693 RETVAL=$?
1694 if test "x$RETVAL" = x0 ; then
1695 HAVE_ETIME=t
1696 DEFINES="$DEFINES -DHAVE_ETIME"
1697 echo "yes"
1698 else
1699 HAVE_ETIME=
1700 echo "no"
1701 fi
1702 rm -f genmake_tcomp*
1703
1704 printf " Can we call simple C routines (here, \"cloc()\") using $FC... "
1705 check_HAVE_CLOC
1706 if test "x$HAVE_CLOC" != x ; then
1707 echo "yes"
1708 else
1709 echo "no"
1710 if test "x$EMBED_SRC" = xt ; then
1711 echo " WARNING: you requested file embedding but it has"
1712 echo " been disabled since C code cannot be called"
1713 EMBED_SRC=
1714 fi
1715 fi
1716 rm -f genmake_t*
1717
1718 printf " Can we unlimit the stack size using $FC... "
1719 check_HAVE_SETRLSTK
1720 if test "x$HAVE_SETRLSTK" = xt ; then
1721 echo "yes"
1722 else
1723 echo "no"
1724 fi
1725 rm -f genmake_t*
1726
1727 printf " Can we register a signal handler using $FC... "
1728 check_HAVE_SIGREG
1729 if test "x$HAVE_SIGREG" = xt ; then
1730 echo "yes"
1731 else
1732 echo "no"
1733 fi
1734 rm -f genmake_t*
1735
1736 printf " Can we use stat() through C calls... "
1737 check_HAVE_STAT
1738 if test "x$HAVE_STAT" != x ; then
1739 echo "yes"
1740 else
1741 echo "no"
1742 fi
1743 rm -f genmake_t*
1744
1745 printf " Can we create NetCDF-enabled binaries... "
1746 check_netcdf_libs
1747 if test "x$HAVE_NETCDF" != x ; then
1748 echo "yes"
1749 else
1750 echo "no"
1751 fi
1752 DEFINES="$DEFINES $IGNORE_TIME"
1753
1754 if test "x$EMBED_SRC" = xt ; then
1755 build_embed_encode
1756 fi
1757 if test "x$EMBED_SRC" = xt ; then
1758 ENABLE="$ENABLE embed_files"
1759 fi
1760
1761
1762 printf "\n=== Setting defaults ===\n"
1763 printf " Adding MODS directories: "
1764 for d in $MODS ; do
1765 if test ! -d $d ; then
1766 echo
1767 echo "Error: MODS directory \"$d\" not found!"
1768 exit 1
1769 else
1770 printf " $d"
1771 SOURCEDIRS="$SOURCEDIRS $d"
1772 INCLUDEDIRS="$INCLUDEDIRS $d"
1773 fi
1774 done
1775 echo
1776
1777 if test "x${PLATFORM}" = x ; then
1778 PLATFORM=$p_PLATFORM
1779 fi
1780
1781 if test "x${EXEDIR}" = x ; then
1782 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1783 if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1784 EXEDIR=../exe
1785 else
1786 EXEDIR=.
1787 fi
1788 fi
1789 if test ! -d ${EXEDIR} ; then
1790 echo "Error: the specified EXEDIR (\"$EXEDIR\") does not exist!"
1791 exit 1
1792 fi
1793
1794 if test "x${TOOLSDIR}" = x ; then
1795 TOOLSDIR="$ROOTDIR/tools"
1796 fi
1797 if test ! -d ${TOOLSDIR} ; then
1798 echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1799 exit 1
1800 fi
1801 if test "x$S64" = x ; then
1802 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1803 RETVAL=$?
1804 if test "x${RETVAL}" = x0 ; then
1805 S64='$(TOOLSDIR)/set64bitConst.sh'
1806 else
1807 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1808 RETVAL=$?
1809 if test "x${RETVAL}" = x0 ; then
1810 S64='$(TOOLSDIR)/set64bitConst.csh'
1811 else
1812 cat <<EOF
1813
1814 ERROR: neither of the two default scripts:
1815
1816 ${TOOLSDIR}/set64bitConst.sh
1817 ${TOOLSDIR}/set64bitConst.csh
1818
1819 are working so please check paths or specify (with \$S64) a
1820 working version of this script.
1821
1822 EOF
1823 exit 1
1824 fi
1825 fi
1826 fi
1827 THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1828
1829 EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1830
1831 # We have a special set of source files in eesupp/src which are
1832 # generated from some template source files. We'll make them first so
1833 # they appear as regular source code
1834 if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1835 echo " Making source files in eesupp from templates"
1836 ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1837 RETVAL=$?
1838 if test "x${RETVAL}" = x0 ; then
1839 rm -f make_eesupp.errors
1840 else
1841 echo "Error: problem encountered while building source files in eesupp:"
1842 cat make_eesupp.errors 1>&2
1843 exit 1
1844 fi
1845 fi
1846
1847 #same for pkg/exch2 and pkg/regrid
1848 for pdir in exch2 regrid ; do
1849 if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1850 echo " Making source files in pkg/${pdir} from templates"
1851 ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1852 RETVAL=$?
1853 if test "x${RETVAL}" = x0 ; then
1854 rm -f make_${pdir}.errors
1855 else
1856 echo "Error: problem encountered while building source files in pkg/${pdir}:"
1857 cat make_${pdir}.errors 1>&2
1858 exit 1
1859 fi
1860 fi
1861 done
1862
1863 printf "\n=== Determining package settings ===\n"
1864 if test "x${PDEPEND}" = x ; then
1865 tmp=$ROOTDIR"/pkg/pkg_depend"
1866 if test -r $tmp ; then
1867 PDEPEND=$tmp
1868 else
1869 echo "Warning: No package dependency information was specified."
1870 echo " Please check that ROOTDIR/pkg/pkg_depend exists."
1871 fi
1872 else
1873 if test ! -r ${PDEPEND} ; then
1874 echo "Error: can't read package dependency info from PDEPEND=\"$PDEPEND\""
1875 exit 1
1876 fi
1877 fi
1878 echo " getting package dependency info from $PDEPEND"
1879 # Strip the comments and then convert the dependency file into
1880 # two arrays: PNAME, DNAME
1881 cat $PDEPEND | sed -e 's/#.*$//g' \
1882 | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
1883 > ./.pd_tmp
1884 RETVAL=$?
1885 if test ! "x${RETVAL}" = x0 ; then
1886 echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1887 exit 1
1888 fi
1889 . ./.pd_tmp
1890 rm -f ./.pd_tmp
1891
1892 # Search for default packages. Note that a "$ROOTDIR/pkg/pkg_groups"
1893 # file should eventually be added so that, for convenience, one can
1894 # specify groups of packages using names like "ocean" and "atmosphere".
1895 echo " checking default package list: "
1896 if test "x${PDEFAULT}" = x ; then
1897 for i in "." $MODS ; do
1898 if test -r $i"/packages.conf" ; then
1899 PDEFAULT=$i"/packages.conf"
1900 break
1901 fi
1902 done
1903 fi
1904 if test "x${PDEFAULT}" = x ; then
1905 PDEFAULT="$ROOTDIR/pkg/pkg_default"
1906 fi
1907 if test "x${PDEFAULT}" = xNONE ; then
1908 echo " default packages file disabled"
1909 else
1910 if test ! -r $PDEFAULT ; then
1911 echo "Warning: can't read default packages from PDEFAULT=\"$PDEFAULT\""
1912 else
1913 echo " using PDEFAULT=\"$PDEFAULT\""
1914 # Strip the comments and add all the names
1915 def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1916 RETVAL=$?
1917 if test "x${RETVAL}" != x0 ; then
1918 printf "Error: can't parse default package list "
1919 echo "-- please check PDEFAULT=\"$PDEFAULT\""
1920 exit 1
1921 fi
1922 for i in $def ; do
1923 PACKAGES="$PACKAGES $i"
1924 done
1925 echo " before group expansion packages are: $PACKAGES"
1926 RET=1
1927 while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1928 echo " after group expansion packages are: $PACKAGES"
1929 fi
1930 fi
1931
1932 echo " applying DISABLE settings"
1933 for i in $PACKAGES ; do
1934 echo $i >> ./.tmp_pack
1935 done
1936 for i in `grep "-" ./.tmp_pack` ; do
1937 j=`echo $i | sed 's/[-]//'`
1938 DISABLE="$DISABLE $j"
1939 done
1940 pack=
1941 for p in $PACKAGES ; do
1942 addit="t"
1943 for d in $DISABLE ; do
1944 if test "x$p" = "x$d" ; then
1945 addit="f"
1946 fi
1947 done
1948 if test "x$addit" = xt ; then
1949 pack="$pack $p"
1950 fi
1951 done
1952 PACKAGES="$pack"
1953 echo " applying ENABLE settings"
1954 echo "" > ./.tmp_pack
1955 PACKAGES="$PACKAGES $ENABLE"
1956 # Test if each explicitly referenced package exists
1957 for i in $PACKAGES ; do
1958 j=`echo $i | sed 's/[-+]//'`
1959 if test ! -d "$ROOTDIR/pkg/$j" ; then
1960 echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1961 exit 1
1962 fi
1963 echo $i >> ./.tmp_pack
1964 done
1965 PACKAGES=
1966 for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1967 PACKAGES="$PACKAGES $i"
1968 done
1969 rm -f ./.tmp_pack
1970 echo " packages are: $PACKAGES"
1971
1972 # Check for package MNC: if NetCDF is available, then build the MNC
1973 # template files ; otherwise, delete mnc from the list of packages.
1974 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1975 RETVAL=$?
1976 if test "x$RETVAL" = x0 ; then
1977 if test "x$HAVE_NETCDF" != xt ; then
1978 cat <<EOF
1979
1980 *********************************************************************
1981 WARNING: the "mnc" package was enabled but tests failed to compile
1982 NetCDF applications. Please check that:
1983
1984 1) NetCDF is correctly installed for this compiler and
1985 2) the LIBS variable (within the "optfile") specifies the correct
1986 NetCDF library to link against.
1987
1988 Due to this failure, the "mnc" package is now DISABLED.
1989 *********************************************************************
1990
1991 EOF
1992 PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1993 DISABLE="$DISABLE mnc"
1994 else
1995 ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1996 RETVAL=$?
1997 if test "x${RETVAL}" = x0 ; then
1998 rm -f make_mnc.errors
1999 else
2000 echo "Error: problem encountered while building source files in pkg/mnc:"
2001 cat make_mnc.errors 1>&2
2002 exit 1
2003 fi
2004 fi
2005 fi
2006
2007 # Check for package PROFILES: if NetCDF is not available,
2008 # then delete profiles from the list of available packages.
2009 echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2010 RETVAL=$?
2011 if test "x$RETVAL" = x0 ; then
2012 if test "x$HAVE_NETCDF" != xt ; then
2013 cat <<EOF
2014
2015 *********************************************************************
2016 WARNING: the "profiles" package was enabled but tests failed to
2017 compile NetCDF applications. Please check that:
2018
2019 1) NetCDF is correctly installed for this compiler and
2020 2) the LIBS variable (within the "optfile") specifies the correct
2021 NetCDF library to link against.
2022
2023 Due to this failure, the "profiles" package is now DISABLED.
2024 *********************************************************************
2025
2026 EOF
2027 PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2028 DISABLE="$DISABLE profiles"
2029 fi
2030 fi
2031
2032 echo " applying package dependency rules"
2033 ck=
2034 while test "x$ck" != xtt ; do
2035 i=0
2036 # rtot=${#PNAME[@]}
2037 rtot=$nname
2038 while test $i -le $rtot ; do
2039
2040 # Is $pname in the current $PACKAGES list?
2041 # pname=${PNAME[$i]}
2042 tmp="pname=\"\$PNAME_$i\""
2043 eval $tmp
2044 pin="f"
2045 for p in $PACKAGES ; do
2046 if test "x$p" = "x$pname" ; then
2047 pin="t"
2048 fi
2049 done
2050
2051 # Is the DNAME entry a (+) or (-) rule ?
2052 tmp="dname=\"\$DNAME_$i\""
2053 eval $tmp
2054 plus="-"
2055 echo $dname | grep '^+' > /dev/null 2>&1
2056 RETVAL=$?
2057 if test "x$RETVAL" = x0 ; then
2058 plus="+"
2059 fi
2060
2061 # Is $dname in the current $PACKAGES list?
2062 dname=`echo $dname | sed -e 's/^[+-]//'`
2063 din="f"
2064 for p in $PACKAGES ; do
2065 if test "x$p" = "x$dname" ; then
2066 din="t"
2067 fi
2068 done
2069
2070 # Do we need to add $dname according to the dependency rules?
2071 if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2072 #echo " " $pname ": need to add :" $dname
2073 in_dis="f"
2074 for dis in $DISABLE ; do
2075 if test "x$dis" = "x$dname" ; then
2076 in_dis="t"
2077 fi
2078 done
2079 if test "x$in_dis" = xt ; then
2080 echo "Error: can't satisfy package dependencies:"
2081 echo " \"$dname\" is required by the dependency rules"
2082 echo " but is disallowed by the DISABLE settings"
2083 exit 1
2084 else
2085 PACKAGES="$PACKAGES $dname"
2086 ck=
2087 fi
2088 fi
2089
2090 # Do we need to get rid of $dname according to the dependency rules?
2091 if test "x$pin" = xt -a "x$plus" = "x-" -a "x$din" = xt; then
2092 echo "Error: can't satisfy package dependencies:"
2093 echo " \"$pname\" was requested but is disallowed by"
2094 echo " the dependency rules for \"$dname\""
2095 exit 1
2096 fi
2097 i=`echo "$i + 1" | bc -l`
2098 #i=$(( $i + 1 ))
2099 done
2100 ck=$ck"t"
2101 done
2102 echo " packages are: $PACKAGES"
2103 for i in $PACKAGES ; do
2104 adr="$ROOTDIR/pkg/$i"
2105 if test -d $adr ; then
2106 SOURCEDIRS="$SOURCEDIRS $adr"
2107 INCLUDEDIRS="$INCLUDEDIRS $adr"
2108 if test "x$i" = xautodiff ; then
2109 AUTODIFF_PKG_USED=t
2110 fi
2111 else
2112 echo "Error: the directory \"$adr\" for package $i doesn't exist"
2113 exit 1
2114 fi
2115 done
2116
2117 # Create a list of #define and #undef to enable/disable packages
2118 PACKAGES_DOT_H=PACKAGES_CONFIG.h
2119 # The following UGLY HACK sets multiple "#undef"s and it needs to go
2120 # away. On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
2121 # file would eventually be split up so that all package-related #define
2122 # statements could be separated and handled only by genmake.
2123 names=`ls -1 "$ROOTDIR/pkg"`
2124 all_pack=
2125 DISABLED_PACKAGES=
2126 for n in $names ; do
2127 if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
2128 has_pack="f"
2129 for pack in $PACKAGES ; do
2130 if test "x$pack" = "x$n" ; then
2131 has_pack="t"
2132 break
2133 fi
2134 done
2135 if test "x$has_pack" = xf ; then
2136 undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2137 DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2138 fi
2139 fi
2140 done
2141 ENABLED_PACKAGES=
2142 for i in $PACKAGES ; do
2143 def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2144 ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2145 #eh3 DEFINES="$DEFINES -D$def"
2146
2147 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2148 case $i in
2149 aim_v23)
2150 ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
2151 echo "Warning: ALLOW_AIM is set to enable aim_v23."
2152 ;;
2153 esac
2154 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2155
2156 done
2157
2158 echo " Adding STANDARDDIRS"
2159 BUILDDIR=${BUILDDIR:-.}
2160 if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
2161 STANDARDDIRS="eesupp model"
2162 fi
2163 if test "x$STANDARDDIRS" != x ; then
2164 for d in $STANDARDDIRS ; do
2165 adr="$ROOTDIR/$d/src"
2166 if test ! -d $adr ; then
2167 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2168 echo " is correct and that you correctly specified the STANDARDDIRS option"
2169 exit 1
2170 else
2171 SOURCEDIRS="$SOURCEDIRS $adr"
2172 fi
2173 adr="$ROOTDIR/$d/inc"
2174 if test ! -d $adr ; then
2175 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2176 echo " is correct and that you correctly specified the STANDARDDIRS option"
2177 exit 1
2178 else
2179 INCLUDEDIRS="$INCLUDEDIRS $adr"
2180 fi
2181 done
2182 fi
2183
2184 echo " Searching for *OPTIONS.h files in order to warn about the presence"
2185 echo " of \"#define \"-type statements that are no longer allowed:"
2186 CPP_OPTIONS=
2187 CPP_EEOPTIONS=
2188 spaths=". $INCLUDEDIRS"
2189 names=`ls -1 "$ROOTDIR/pkg"`
2190 for i in $spaths ; do
2191 try="$i/CPP_OPTIONS.h"
2192 if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
2193 echo " found CPP_OPTIONS=\"$try\""
2194 CPP_OPTIONS="$try"
2195 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
2196 for n in $names ; do
2197 test_for_package_in_cpp_options $CPP_OPTIONS $n
2198 done
2199 fi
2200 try="$i/CPP_EEOPTIONS.h"
2201 if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
2202 echo " found CPP_EEOPTIONS=\"$try\""
2203 # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
2204 #**** not yet enabled ****
2205 # test_for_mpi_in_cpp_eeoptions $try
2206 #**** not yet enabled ****
2207 CPP_EEOPTIONS="$try"
2208 fi
2209 done
2210 if test "x$CPP_OPTIONS" = x ; then
2211 echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
2212 exit 1
2213 fi
2214
2215 # Here, we build the list of files to be "run through" the adjoint
2216 # compiler.
2217 if test -f ./ad_files ; then
2218 rm -f ./ad_files
2219 fi
2220 echo " Creating the list of files for the adjoint compiler."
2221 for i in $SOURCEDIRS ; do
2222 list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
2223 for j in $list_files ; do
2224 cat $i/$j >> ad_files
2225 done
2226 done
2227 if test ! "x"$FS = "x.f" ; then
2228 cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f
2229 mv -f ad_files_f ad_files
2230 fi
2231
2232 echo
2233 echo "=== Creating the Makefile ==="
2234 echo " setting INCLUDES"
2235 for i in $INCLUDEDIRS ; do
2236 if test ! -d $i ; then
2237 echo "Warning: can't find INCLUDEDIRS=\"$i\""
2238 fi
2239 done
2240
2241 if test ! "x$DIVA" = x ; then
2242 echo " Creating the pseudo-MPI include directory"
2243 INCLUDES="-I./mpi_headers $INCLUDES"
2244 rm -rf ./mpi_headers
2245 mkdir -p ./mpi_headers
2246
2247 if test "x$MPIINCLUDEDIR" = x ; then
2248 if test "x$MPIHOME" = x ; then
2249 MPIHOME='/usr'
2250 fi
2251 MPIINCLUDEDIR='$MPIHOME/include'
2252 fi
2253
2254 if test -r $MPIINCLUDEDIR/mpif.h ; then
2255 for i in $MPI_HEADER_FILES; do
2256 cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2257 done
2258
2259 perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2260 else
2261 echo " We cannot create a copy of mpif.h!"
2262 # exit -1
2263 fi
2264 fi
2265
2266 echo " Determining the list of source and include files"
2267 rm -rf .links.tmp
2268 mkdir .links.tmp
2269 touch .links.tmp/foo
2270 if test ! -r ".links.tmp/foo" ; then
2271 echo
2272 echo "ERROR : something is wrong with your directory permissions or"
2273 echo " your user file-creation mask (\"umask\") since creating a"
2274 echo " sub-dir, touch-ing a file within it, and then reading it is"
2275 echo " not working. Please try setting your umask to something"
2276 echo " sane such as:"
2277 echo
2278 echo " umask 0002"
2279 echo
2280 echo " and please verify that you have the proper permissions for"
2281 echo " creating sub-directories and then reading files created"
2282 echo " within them."
2283 echo
2284 exit 1
2285 fi
2286 rm -f .links.tmp/foo
2287 echo "# This section creates symbolic links" > srclinks.tmp
2288 echo "" >> srclinks.tmp
2289 printf 'SRCFILES = ' > srclist.inc
2290 printf 'CSRCFILES = ' > csrclist.inc
2291 printf 'F90SRCFILES = ' > f90srclist.inc
2292 printf 'HEADERFILES = ' > hlist.inc
2293 printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
2294 alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2295 for d in $alldirs ; do
2296 deplist=
2297 sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
2298 sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
2299 for sf in $sfiles ; do
2300 if test ! -r ".links.tmp/$sf" ; then
2301 if test -f "$d/$sf" ; then
2302 ignore_f=f
2303 case $d/$sf in
2304 ./$PACKAGES_DOT_H)
2305 ignore_f=t
2306 ;;
2307 ./AD_CONFIG.h)
2308 ignore_f=t
2309 ;;
2310 ./FC_NAMEMANGLE.h)
2311 ignore_f=t
2312 ;;
2313 ./BUILD_INFO.h)
2314 ignore_f=t
2315 ;;
2316 ./EMBEDDED_FILES.h)
2317 ignore_f=t
2318 ;;
2319 *)
2320 # For the local directory *ONLY*,
2321 # ignore all soft-links
2322 if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2323 ignore_f=t
2324 else
2325 touch .links.tmp/$sf
2326 deplist="$deplist $sf"
2327 fi
2328 ;;
2329 esac
2330 if test "x$ignore_f" = xf ; then
2331 extn=`echo $sf | $AWK -F. '{print $NF}'`
2332 case $extn in
2333 F)
2334 echo " \\" >> srclist.inc
2335 printf " $sf" >> srclist.inc
2336 ;;
2337 F90)
2338 echo " \\" >> f90srclist.inc
2339 printf " $sf" >> f90srclist.inc
2340 ;;
2341 c)
2342 echo " \\" >> csrclist.inc
2343 printf " $sf" >> csrclist.inc
2344 ;;
2345 h)
2346 echo " \\" >> hlist.inc
2347 printf " $sf" >> hlist.inc
2348 ;;
2349 flow)
2350 echo " \\" >> ad_flow_files.inc
2351 printf " $sf" >> ad_flow_files.inc
2352 ;;
2353 esac
2354 fi
2355 fi
2356 fi
2357 done
2358 if test "x$deplist" != x ; then
2359 echo "" >> srclinks.tmp
2360 echo "# These files are linked from $d" >> srclinks.tmp
2361 echo "$deplist :" >> srclinks.tmp
2362 printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp
2363 fi
2364 done
2365 rm -rf .links.tmp
2366 echo "" >> srclist.inc
2367 echo "" >> csrclist.inc
2368 echo "" >> f90srclist.inc
2369 echo "" >> hlist.inc
2370 echo "" >> ad_flow_files.inc
2371
2372 if test -f $MAKEFILE ; then
2373 mv -f $MAKEFILE "$MAKEFILE.bak"
2374 fi
2375 echo " Writing makefile: $MAKEFILE"
2376 echo "# Multithreaded + multi-processing makefile for:" > $MAKEFILE
2377 echo "# $MACHINE" >> $MAKEFILE
2378 echo "# This makefile was generated automatically on" >> $MAKEFILE
2379 echo "# $THISDATE" >> $MAKEFILE
2380 echo "# by the command:" >> $MAKEFILE
2381 echo "# $0 $G2ARGS" >> $MAKEFILE
2382 echo "# executed by:" >> $MAKEFILE
2383 echo "# ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
2384
2385 EXE_AD=$EXECUTABLE"_ad"
2386 EXE_FTL=$EXECUTABLE"_ftl"
2387 EXE_SVD=$EXECUTABLE"_svd"
2388
2389 cat >>$MAKEFILE <<EOF
2390 #
2391 # OPTFILE="$OPTFILE"
2392 #
2393 # BUILDDIR : Directory where object files are written
2394 # SOURCEDIRS : Directories containing the source (.F) files
2395 # INCLUDEDIRS : Directories containing the header-source (.h) files
2396 # EXEDIR : Directory where executable that is generated is written
2397 # EXECUTABLE : Full path of executable binary
2398 #
2399 # CPP : C-preprocessor command
2400 # INCLUDES : Directories searched for header files
2401 # DEFINES : Macro definitions for CPP
2402 # MAKEDEPEND : Dependency generator
2403 # KPP : Special preprocessor command (specific to platform)
2404 # KFLAGS : Flags for KPP
2405 # FC : Fortran compiler command
2406 # FFLAGS : Configuration/debugging options for FC
2407 # FOPTIM : Optimization options for FC
2408 # LINK : Command for link editor program
2409 # LIBS : Library flags /or/ additional optimization/debugging flags
2410
2411 ROOTDIR = ${ROOTDIR}
2412 BUILDDIR = ${BUILDDIR}
2413 SOURCEDIRS = ${SOURCEDIRS}
2414 INCLUDEDIRS = ${INCLUDEDIRS}
2415 EXEDIR = ${EXEDIR}
2416 EXECUTABLE = \$(EXEDIR)/${EXECUTABLE}
2417 TOOLSDIR = ${TOOLSDIR}
2418
2419 #eh3 new defines for the adjoint work
2420 AUTODIFF = ${ROOTDIR}/pkg/autodiff
2421 EXE_AD = ${EXE_AD}
2422 EXE_FTL = ${EXE_FTL}
2423 EXE_SVD = ${EXE_SVD}
2424
2425 ENABLED_PACKAGES = ${ENABLED_PACKAGES}
2426 DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2427
2428 # These files are created by Makefile
2429 SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
2430 EOF
2431
2432 if test "x$EMBED_SRC" = xt ; then
2433 echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2434 else
2435 echo "EMBEDDED_FILES = " >>$MAKEFILE
2436 fi
2437
2438 # Note: figure out some way to add Hyades JAM libraries here
2439 cat >>$MAKEFILE <<EOF
2440 # Unix ln (link)
2441 LN = ${LN}
2442 # C preprocessor
2443 CPP = cat \$< | ${S64} | ${CPP}
2444 # Dependency generator
2445 MAKEDEPEND = ${MAKEDEPEND}
2446 # Special preprocessor (KAP on DECs, FPP on Crays)
2447 KPP = ${KPP}
2448 # Fortran compiler
2449 FC = ${FC}
2450 # Fortran compiler
2451 F90C = ${F90C}
2452 # C compiler
2453 CC = ${CC}
2454 # Link editor
2455 LINK = ${LINK} ${LDADD}
2456
2457 # Defines for CPP
2458 DEFINES = ${DEFINES}
2459 # Includes for CPP
2460 INCLUDES = ${INCLUDES}
2461 # Flags for KPP
2462 KFLAGS1 = ${KFLAGS1}
2463 KFLAGS2 = ${KFLAGS2}
2464 # Optim./debug for FC
2465 FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2466 FOPTIM = ${FOPTIM}
2467 # Optim./debug for FC
2468 F90FLAGS = ${F90FLAGS}
2469 F90OPTIM = ${F90OPTIM}
2470 # Flags for CC
2471 CFLAGS = ${CFLAGS}
2472 # Files that should not be optimized
2473 NOOPTFILES = ${NOOPTFILES}
2474 NOOPTFLAGS = ${NOOPTFLAGS}
2475 # Flags and libraries needed for linking
2476 LIBS = ${LIBS}
2477 # Name of the Mekfile
2478 MAKEFILE=${MAKEFILE}
2479
2480 EOF
2481
2482 cat srclist.inc >> $MAKEFILE
2483 cat csrclist.inc >> $MAKEFILE
2484 cat f90srclist.inc >> $MAKEFILE
2485 cat hlist.inc >> $MAKEFILE
2486 cat ad_flow_files.inc >> $MAKEFILE
2487 echo >> $MAKEFILE
2488 echo 'F77FILES = $(SRCFILES:.F=.'$FS')' >> $MAKEFILE
2489 echo 'F90FILES = $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2490 echo 'OBJFILES = $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2491 echo >> $MAKEFILE
2492 echo '.SUFFIXES:' >> $MAKEFILE
2493 echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
2494 rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
2495 rm -f ad_flow_files.inc
2496
2497 cat >>$MAKEFILE <<EOF
2498
2499 all: \$(EXECUTABLE)
2500 \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2501 @echo Creating \$@ ...
2502 \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2503 depend:
2504 @make links
2505 \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
2506 \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2507 -rm -f makedepend.out
2508
2509 lib: libmitgcmuv.a
2510
2511 libmitgcmuv.a: \$(OBJFILES)
2512 ar rcv libmitgcmuv.a \$(OBJFILES)
2513 ar d libmitgcmuv.a main.o
2514
2515 links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2516
2517 small_f: \$(F77FILES) \$(F90FILES)
2518
2519 output.txt: \$(EXECUTABLE)
2520 @printf 'running ... '
2521 @\$(EXECUTABLE) > \$@
2522
2523 clean:
2524 -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2525 -rm -rf *.o
2526 -rm -rf *.$FS
2527 Clean:
2528 @make clean
2529 @make cleanlinks
2530 -rm -f \$(SPECIAL_FILES)
2531 -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2532 -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2533 CLEAN:
2534 @make Clean
2535 -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2536 -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2537 -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2538 -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2539 -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2540 -rm -rf mnc_test_*
2541
2542 #eh3 Makefile: makefile
2543 makefile:
2544 $THIS_SCRIPT $G2ARGS
2545 cleanlinks:
2546 -find . -type l -exec rm {} \;
2547
2548 # Special targets (SPECIAL_FILES) which are create by make
2549 ${PACKAGES_DOT_H}:
2550 @echo Creating \$@ ...
2551 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2552 AD_CONFIG.h:
2553 @echo Creating \$@ ...
2554 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2555 FC_NAMEMANGLE.h:
2556 @echo Creating \$@ ...
2557 echo "$FC_NAMEMANGLE" > \$@
2558
2559 BUILD_INFO.h:
2560 @echo Creating \$@ ...
2561 EOF
2562
2563 test ! "x$THISVER" = x && echo " -echo \"#define THISVER '$THISVER'\" > \$@" >> $MAKEFILE
2564 test ! "x$THISUSER" = x && echo " -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2565 test ! "x$THISDATE" = x && echo " -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2566 test ! "x$THISHOST" = x && echo " -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2567
2568 if test "x$EMBED_SRC" = xt ; then
2569 cat >>$MAKEFILE <<EOF
2570
2571 decode_files.o : EMBEDDED_FILES.h
2572
2573 ## \$(F77FILES)
2574 all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2575 @echo Creating \$@ ...
2576 -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2577 -rm -f all_fF.tar.gz
2578 -gzip all_fF.tar
2579
2580 EMBEDDED_FILES.h : all_fF.tar.gz
2581 @echo Creating \$@ ...
2582 -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2583
2584 EOF
2585 fi
2586
2587 cat >>$MAKEFILE <<EOF
2588
2589 # The normal chain of rules is ( .F - .$FS - .o )
2590
2591 ## This nullifies any default implicit rules concerning these two file types:
2592 ## %.o : %.F
2593
2594 .F.$FS:
2595 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2596 .$FS.o:
2597 \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2598 .F90.o:
2599 \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2600 .c.o:
2601 \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2602
2603 # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2604 .F.p:
2605 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2606 .p.$FS:
2607 \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2608
2609 #=========================================
2610 #=== Automatic Differentiation Rules ===
2611
2612 TAMC = ${TAMC}
2613 TAF = ${TAF}
2614
2615 TAF_EXTRA = ${TAF_EXTRA}
2616 TAMC_EXTRA = ${TAMC_EXTRA}
2617
2618 EOF
2619
2620 ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
2621 ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
2622 ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2623 for i in $ad_vars ; do
2624 name=$i
2625 t1="t2=\$"`echo "$i"`
2626 eval $t1
2627 printf "%-20s = " $name >> $MAKEFILE
2628 echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2629 done
2630
2631 echo " Add the source list for AD code generation"
2632 echo >> $MAKEFILE
2633 printf "AD_FILES = " >> $MAKEFILE
2634 AD_FILES=`cat ad_files`
2635 for i in $AD_FILES ; do
2636 echo " \\" >> $MAKEFILE
2637 printf " $i" >> $MAKEFILE
2638 done
2639 echo >> $MAKEFILE
2640 rm -f ad_files
2641
2642 cat >>$MAKEFILE <<EOF
2643
2644 # ... AD ...
2645 adall: \$(EXE_AD)
2646 adtaf: ad_taf_output.$FS
2647 adtamc: ad_tamc_output.$FS
2648
2649 ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2650 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2651 cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2652 -rm -f ad_config.template
2653 @make \$(F77FILES)
2654 @make \$(AD_FLOW_FILES)
2655 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS
2656
2657 ad_taf_output.$FS: ad_input_code.$FS
2658 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2659 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2660
2661 adtafonly:
2662 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2663 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2664
2665 \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2666 \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2667
2668 ad_tamc_output.$FS: ad_input_code.$FS
2669 \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2670 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2671
2672 ad_tamc: ad_tamc_output.o \$(OBJFILES)
2673 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2674
2675 adonlyfwd:
2676 patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2677
2678 adtrick:
2679 patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2680
2681 # ... FTL ...
2682 ftlall: ftl_taf
2683 ftltaf: ftl_taf_output.$FS
2684 ftltamc: ftl_tamc_output.$FS
2685
2686 ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2687 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2688 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2689 -rm -f ftl_config.template
2690 @make \$(F77FILES)
2691 @make \$(AD_FLOW_FILES)
2692 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2693
2694 ftl_taf_output.$FS: ftl_input_code.$FS
2695 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2696 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2697
2698 ftltafonly:
2699 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2700 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2701
2702 ftl_taf: ftl_taf_output.o \$(OBJFILES)
2703 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2704
2705 ftl_tamc_output.$FS: ftl_input_code.$FS
2706 \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2707 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2708
2709 ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2710 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2711
2712
2713 # ... SVD ...
2714 svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2715 @echo "--->>> Only ran TAF to generate SVD code! <<<---"
2716 @echo "--->>> Do make svdall afterwards to compile. <<<---"
2717 svdall: svd_touch svd_taf
2718
2719 svd_taf: \$(OBJFILES)
2720 \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2721
2722 @echo "--->>> Only COMPILE svd code! <<<---"
2723 @echo "--->>> Assumes you previously <<<---"
2724 @echo "--->>> did make svdtaf <<<---"
2725
2726 svd_touch:
2727 @echo "--->>> Only COMPILE svd code! <<<---"
2728 @echo "--->>> Assumes you previously <<<---"
2729 @echo "--->>> did make svdtaf <<<---"
2730 touch ad_taf_output.$FS ftl_taf_output.$FS
2731 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2732 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2733 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2734 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2735 -rm -f ftl_config.template
2736
2737 #=========================================
2738
2739 EOF
2740
2741 if test "x$EXEHOOK" != x ; then
2742 printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
2743 fi
2744
2745 echo " Making list of \"exceptions\" that need \".p\" files"
2746 for i in $KPPFILES ; do
2747 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
2748 RETVAL=$?
2749 if test "x$RETVAL" != x0 ; then
2750 echo "Error: unable to add file \"$i\" to the exceptions list"
2751 fi
2752 echo "$base.$FS: $base.p" >> $MAKEFILE
2753 done
2754
2755 echo " Making list of NOOPTFILES"
2756 for i in $NOOPTFILES ; do
2757 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
2758 RETVAL=$?
2759 if test "x$RETVAL" != x0 ; then
2760 echo "Error: unable to add file \"$i\" to the exceptions list"
2761 fi
2762 echo "$base.o: $base.$FS" >> $MAKEFILE
2763 printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2764 done
2765
2766 echo " Add rules for links"
2767 cat srclinks.tmp >> $MAKEFILE
2768 rm -f srclinks.tmp
2769
2770 echo " Adding makedepend marker"
2771 printf "\n\n# DO NOT DELETE\n" >> $MAKEFILE
2772
2773 printf "\n=== Done ===\n"
2774
2775 # Create special header files
2776 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2777 if test ! -f $PACKAGES_DOT_H ; then
2778 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2779 else
2780 cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2781 RETVAL=$?
2782 if test "x$RETVAL" = x0 ; then
2783 rm -f $PACKAGES_DOT_H".tmp"
2784 else
2785 mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2786 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2787 fi
2788 fi
2789 if test ! -f AD_CONFIG.h ; then
2790 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2791 fi
2792
2793
2794 # Write the "state" for future records
2795 if test "x$DUMPSTATE" != xf ; then
2796 printf "" > genmake_state
2797 for i in $gm_state ; do
2798 t1="t2=\$$i"
2799 eval $t1
2800 echo "$i='$t2'" >> genmake_state
2801 done
2802 fi

  ViewVC Help
Powered by ViewVC 1.1.22